Index: /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 2255)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.cpp	(revision 2332)
@@ -27,5 +27,5 @@
 #define USE_VOLUMES_FOR_HEURISTICS 1
 #define TEST_POWERPLANT 0
-#define USE_BETTER_RENDERCOST_EST 0
+
 
 //int BvhNode::sMailId = 10000;
@@ -53,5 +53,4 @@
 /*              class BvhNode implementation                   */
 /***************************************************************/
-
 
 BvhNode::BvhNode(): 
@@ -387,4 +386,76 @@
 
 
+void BvHierarchy::UpdateViewCells(const BvhSubdivisionCandidate &sc)
+{
+	ViewCellContainer viewCells, frontViewCells, backViewCells;
+	
+	CollectViewCells(*sc.mParentData.mSampledObjects, viewCells, false, false);
+	CollectViewCells(sc.mSampledFrontObjects, frontViewCells, false, false);
+	CollectViewCells(sc.mSampledBackObjects, backViewCells, false, false);
+
+	const float frontTri = (float)sc.mFrontObjects.size();
+	const float backTri = (float)sc.mBackObjects.size();
+	const float totalTri = (float)(*sc.mParentData.mSortedObjects[0]).size();
+
+	ViewCell::NewMail(3);
+
+	ViewCellContainer::const_iterator fit, fit_end = frontViewCells.end();
+
+	for (fit = frontViewCells.begin(); fit != fit_end; ++ fit)
+	{
+		ViewCell *vc = *fit;
+		vc->Mail(0);
+	}
+
+	ViewCellContainer::const_iterator bit, bit_end = backViewCells.end();
+
+	for (bit = backViewCells.begin(); bit != bit_end; ++ bit)
+	{
+		ViewCell *vc = *bit;
+
+		if (vc->Mailed(0))
+			vc->Mail(2);
+		else
+			vc->Mail(1);
+	}
+
+	ViewCellContainer::const_iterator vit, vit_end = viewCells.end();
+	
+	for (vit = viewCells.begin(); vit != viewCells.end(); ++ vit)
+	{
+		ViewCell *vc = *vit;
+
+		float vcTri;
+		int vcObj;
+
+		float oldVcTri = vc->GetPvsCost();
+		int oldVcObj = vc->GetEntriesInPvs();
+
+		// both objects in view cell
+		if (vc->Mailed(2))
+		{
+			vcTri = oldVcTri;
+			vcObj = oldVcObj + 1;   
+		}
+		else if (vc->Mailed(1))
+		{
+			vcTri = oldVcTri - totalTri + backTri; 
+			vcObj = oldVcObj;   
+		}
+		else // (vc->Mailed(0))
+		{
+			vcTri = oldVcTri - totalTri + frontTri; 
+			vcObj = oldVcObj;
+		}
+
+		vc->SetPvsCost(vcTri);
+		vc->SetEntriesInPvs(vcObj);
+
+		//cout << "old pvs tri: " << oldVcTri << " new: " << vcTri << endl;
+		//cout << "old pvs obj: " << oldVcObj << " new: " << vcObj<< endl;
+	}
+}
+
+
 BvhInterior *BvHierarchy::SubdivideNode(const BvhSubdivisionCandidate &sc,
 										BvhTraversalData &frontData,
@@ -439,5 +510,5 @@
 
  
-	////////////////////////////////////////
+	////////////////////////////////
 	//-- fill front and back traversal data with the new values
 
@@ -467,6 +538,6 @@
 	//-- compute pvs correction to cope with undersampling
 
-	frontData.mPvs = (float)sc.mNumFrontViewCells;//(float)CountViewCells(sc.mSampledFrontObjects);
-	backData.mPvs = (float)sc.mNumBackViewCells;//(float)CountViewCells(sc.mSampledBackObjects);
+	frontData.mPvs = (float)sc.mNumFrontViewCells;
+	backData.mPvs = (float)sc.mNumBackViewCells;
 
 	frontData.mCorrectedPvs = sc.mCorrectedFrontPvs;
@@ -476,6 +547,6 @@
 	// compute probability of this node being visible, 
 	// i.e., volume of the view cells that can see this node
-	frontData.mVolume = sc.mVolumeFrontViewCells;//EvalViewCellsVolume(sc.mSampledFrontObjects) / GetViewSpaceVolume();
-	backData.mVolume = sc.mVolumeBackViewCells;//EvalViewCellsVolume(sc.mSampledBackObjects) / GetViewSpaceVolume();
+	frontData.mVolume = sc.mVolumeFrontViewCells;
+	backData.mVolume = sc.mVolumeBackViewCells;
 
 	frontData.mCorrectedVolume = sc.mCorrectedFrontVolume;
@@ -495,4 +566,7 @@
 		AssignSortedObjects(sc, frontData, backData);
 	}
+
+	// compute e.g., new render cost decrease after this split
+	UpdateViewCells(sc);
 
 	mNodeTimer.Exit();
@@ -649,4 +723,7 @@
 	mPlaneTimer.Entry();
 
+	const BvhTraversalData &tData = splitCandidate.mParentData;
+	BvhLeaf *leaf = tData.mNode;
+
 #if STORE_VIEWCELLS_WITH_BVH
 	if (preprocessViewCells) // fill view cells cache
@@ -658,11 +735,10 @@
 		splitCandidate.mFrontObjects.clear();
 		splitCandidate.mBackObjects.clear();
+
 		splitCandidate.mSampledFrontObjects.clear();
 		splitCandidate.mSampledBackObjects.clear();
 
 		const bool sufficientSamples = 
-			splitCandidate.mParentData.mNumRays > mMinRaysForVisibility;
-
-		//if (!sufficientSamples) cout << splitCandidate.mParentData.mNumRays << " ";
+			tData.mNumRays > mMinRaysForVisibility;
 
 		const bool useVisibiliyBasedHeuristics = 
@@ -673,5 +749,5 @@
 
 		// compute best object partition
-		const float ratio =	SelectObjectPartition(splitCandidate.mParentData, 
+		const float ratio =	SelectObjectPartition(tData, 
 												  splitCandidate.mFrontObjects, 
 												  splitCandidate.mBackObjects,
@@ -691,78 +767,148 @@
 	mPlaneTimer.Exit();
 
+
+	///////////////////
+
 	mEvalTimer.Entry();
 
-	const BvhTraversalData &tData = splitCandidate.mParentData;
-	BvhLeaf *leaf = tData.mNode;
-
-	// avg contribution of a ray to a pvs
-	const float pvs = (float)CountViewCells(*tData.mSampledObjects);
-	//const float avgRayContri = AvgRayContribution((int)pvs, tData.mNumRays);
+	ViewCellContainer viewCells, frontViewCells, backViewCells;
+	
+	CollectViewCells(*tData.mSampledObjects, viewCells, false, false);
+	CollectViewCells(splitCandidate.mSampledFrontObjects, frontViewCells, false, false);
+	CollectViewCells(splitCandidate.mSampledBackObjects, backViewCells, false, false);
+
+	// compute view cells seen from front and back side of the split
+	float volFront = 0, volBack = 0, parentVol = 0;
+
+	ViewCell::NewMail(3);
+
+	ViewCellContainer::const_iterator fvit, fvit_end = frontViewCells.end();
+
+	for (fvit = frontViewCells.begin(); fvit != fvit_end; ++ fvit)
+	{
+		ViewCell *vc = *fvit;
+		vc->Mail(0);
+		
+		volFront += vc->GetVolume();
+		parentVol += vc->GetVolume();
+	}
+
+	ViewCellContainer::const_iterator bvit, bvit_end = backViewCells.end();
+	
+	int frontAndBackViewCells = 0;
+
+	for (bvit = backViewCells.begin(); bvit != bvit_end; ++ bvit)
+	{
+		ViewCell *vc = *bvit;
+
+		if (vc->Mailed(0))
+		{
+			// view cell sees front AND on back side
+			++ frontAndBackViewCells;
+			vc->Mail(2);
+		}
+		else
+		{
+			vc->Mail(1);
+			parentVol += vc->GetVolume();
+		}
+
+		volBack += vc->GetVolume();
+	}
+
+	
+	/////////////////////
+	//-- this bvh node is a pvs entry in all the view cells that see one of the objects.
+	
+	// pvs size induced by this bvh node is #view cells
+	const float pvs = (float)viewCells.size();
 	const float avgRaysPerObject = AvgRaysPerObject((int)pvs, tData.mNumRays);
 
-	// high avg ray contri, the result is influenced by undersampling
+	// for low #rays per object => the result is influenced by undersampling
 	splitCandidate.SetAvgRaysPerObject(avgRaysPerObject);
 	const float viewSpaceVol = GetViewSpaceVolume();
 
-	const float oldVolume = EvalViewCellsVolume(*tData.mSampledObjects) / viewSpaceVol;
-	const float oldRatio = (tData.mVolume > 0) ? oldVolume / tData.mVolume : 1;
-	const float parentVol = tData.mCorrectedVolume * oldRatio;
-
-	//cout << "h " << avgRaysPerObject << " ";
-	// this leaf is a pvs entry in all the view cells
-	// that see one of the objects.
-	splitCandidate.mVolumeFrontViewCells = EvalViewCellsVolume(splitCandidate.mSampledFrontObjects) / viewSpaceVol;
-	splitCandidate.mVolumeBackViewCells = EvalViewCellsVolume(splitCandidate.mSampledBackObjects) / viewSpaceVol;
-
-	splitCandidate.mNumFrontViewCells = CountViewCells(splitCandidate.mSampledFrontObjects);
-	splitCandidate.mNumBackViewCells = CountViewCells(splitCandidate.mSampledBackObjects);
-
+	splitCandidate.mVolumeFrontViewCells = volFront / viewSpaceVol;
+	splitCandidate.mVolumeBackViewCells = volBack / viewSpaceVol;
+
+	splitCandidate.mNumFrontViewCells = (int)frontViewCells.size();
+	splitCandidate.mNumBackViewCells = (int)backViewCells.size();
+
+	// currently not working!!
+	// todo matt: fix this to cope with undersampling for new evaluation method
 	splitCandidate.mCorrectedFrontVolume = 
-		mHierarchyManager->EvalCorrectedPvs(splitCandidate.mVolumeFrontViewCells, parentVol, avgRaysPerObject);
+		mHierarchyManager->EvalCorrectedPvs(splitCandidate.mVolumeFrontViewCells, 
+											parentVol, 
+											avgRaysPerObject);
 	
 	splitCandidate.mCorrectedBackVolume = 
-		mHierarchyManager->EvalCorrectedPvs(splitCandidate.mVolumeBackViewCells, parentVol, avgRaysPerObject);
-	
-	const float relfrontCost = splitCandidate.mCorrectedFrontVolume * 
-		EvalAbsCost(splitCandidate.mFrontObjects);
-	const float relBackCost =  splitCandidate.mCorrectedBackVolume * 
-		EvalAbsCost(splitCandidate.mBackObjects);
-	const float relParentCost = parentVol * EvalAbsCost(leaf->mObjects);
+		mHierarchyManager->EvalCorrectedPvs(splitCandidate.mVolumeBackViewCells, 
+											parentVol, 
+											avgRaysPerObject);
+
+	///////////////////////////////////
+
+
+	float newRenderCost = 0, oldRenderCost = 0;
+
+	const float frontTri = (float)splitCandidate.mFrontObjects.size();
+	const float backTri = (float)splitCandidate.mBackObjects.size();
+	// total #triangles in parent
+	const float totalTri = (float)(*tData.mSortedObjects[0]).size();
+
+
+	// compute render cost decrease in the seen view cells
+	ViewCellContainer::const_iterator vit, vit_end = viewCells.end();
+	
+	for (vit = viewCells.begin(); vit != viewCells.end(); ++ vit)
+	{
+		ViewCell *vc = *vit;
+
+		// triangles in this view cell
+		float vcTri;
+		// #entries in this view cell
+		int vcObj;
+
+		float oldVcTri = vc->GetPvsCost();
+		int oldVcObj = vc->GetEntriesInPvs();
+
+		// both nodes in this view cell
+		if (vc->Mailed(2))
+		{
+			vcTri = oldVcTri;
+			// #entries is increasing
+			vcObj = oldVcObj + 1;   
+		}
+		else if (vc->Mailed(1))
+		{
+			// only front node in this view cell: #triangles is decreasing
+			vcTri = oldVcTri - totalTri + backTri; 
+			vcObj = oldVcObj;   
+		}
+		else // (vc->Mailed(0))
+		{
+			// // only back node in this view cell: #triangles is decreasing
+			vcTri = oldVcTri - totalTri + frontTri; 
+			vcObj = oldVcObj;
+		}
+
+		oldRenderCost += mViewCellsManager->ComputeRenderCost((int)oldVcTri, (int)oldVcObj) * vc->GetVolume()  / viewSpaceVol;
+		newRenderCost += mViewCellsManager->ComputeRenderCost((int)vcTri, (int)vcObj) * vc->GetVolume() / viewSpaceVol;
+		//cout << "old rc=" << oldRenderCost << " new rc " << newRenderCost << endl;
+	}
 
 	// compute global decrease in render cost
-	const float newRenderCost = relfrontCost + relBackCost;
-	const float renderCostDecr = relParentCost - newRenderCost;
-	
+	const float renderCostDecr = (oldRenderCost - newRenderCost);
+
+	// for each view cell seen from front and back there is a new entry
+	const int pvsEntriesIncr = frontAndBackViewCells;
+
 	splitCandidate.SetRenderCostDecrease(renderCostDecr);
-
-	// increase in pvs entries
-	const int pvsEntriesIncr = EvalPvsEntriesIncr(splitCandidate, 
-												  avgRaysPerObject, 
-												  (int)pvs, 
-												  splitCandidate.mNumFrontViewCells, 
-												  splitCandidate.mNumBackViewCells);
-
 	splitCandidate.SetPvsEntriesIncr(pvsEntriesIncr);
 
-	if (0)
-	{
-		cout << "bvh volume cost"
-		 << " avg rays per object: " << avgRaysPerObject << " ratio: " << oldRatio 
-		 << " parent: " << parentVol << " old vol: " << oldVolume 
-		 << " frontvol: " << splitCandidate.mVolumeFrontViewCells << " corr. " << splitCandidate.mCorrectedFrontVolume 
-		 << " backvol: " << splitCandidate.mVolumeBackViewCells << " corr. " << splitCandidate.mCorrectedBackVolume << endl;
-	}
-
-#ifdef GTP_DEBUG
-	Debug << "old render cost: " << oldRenderCost << endl;
-	Debug << "new render cost: " << newRenderCost << endl;
-	Debug << "render cost decrease: " << renderCostDecr << endl;
-#endif
-
-	float priority = EvalPriority(splitCandidate, 
-								  renderCostDecr,
-								  relParentCost);
-
-  	// compute global decrease in render cost
+	//cout << "bvh render cost decrease=" << renderCostDecr << endl;
+
+	// at last computed priority based on render cost reduction / memory increase
+	const float priority = EvalPriority(splitCandidate, renderCostDecr,	oldRenderCost);
 	splitCandidate.SetPriority(priority);
 
@@ -782,11 +928,12 @@
 									const int numBackViewCells) //const
 {
-	const float oldPvsSize = (float)numParentViewCells;//CountViewCells(*splitCandidate.mParentData.mSampledObjects);
-	const float oldPvsRatio = (splitCandidate.mParentData.mPvs > 0) ? oldPvsSize / splitCandidate.mParentData.mPvs : 1;
+	const float oldPvsSize = (float)numParentViewCells;
+	const float oldPvsRatio = 
+		(splitCandidate.mParentData.mPvs > 0) ? oldPvsSize / splitCandidate.mParentData.mPvs : 1;
 
 	const float parentPvs = splitCandidate.mParentData.mCorrectedPvs * oldPvsRatio;
 
-	const int frontViewCells = numFrontViewCells;//CountViewCells(splitCandidate.mSampledFrontObjects);
-	const int backViewCells = numBackViewCells;//CountViewCells(splitCandidate.mSampledBackObjects);
+	const int frontViewCells = numFrontViewCells;
+	const int backViewCells = numBackViewCells;
 	
 	splitCandidate.mCorrectedFrontPvs = 
@@ -1036,5 +1183,5 @@
 	PrepareLocalSubdivisionCandidates(tData, axis);
 
-	const float totalRenderCost = EvalAbsCost(tData.mNode->mObjects);
+	const float totalRenderCost = (float)tData.mNode->mObjects.size();
 	float objectsLeft = 0, objectsRight = totalRenderCost;
   
@@ -1088,18 +1235,8 @@
 		Intersectable *obj = (*cit).mObject;
 
-#if USE_BETTER_RENDERCOST_EST
-		const float renderCost = ViewCellsManager::EvalRenderCost(obj);
-		
-		objectsLeft += renderCost;
-		objectsRight -= renderCost;
-
-		const bool noValidSplit = ((objectsLeft <= Limits::Small) || (objectsRight <= Limits::Small));
-
-#else
 		++ objectsLeft;
 		-- objectsRight;
 
-		const bool noValidSplit = !objectsLeft || !objectsRight;
-#endif
+		const bool noValidSplit = ((objectsLeft <= Limits::Small) || (objectsRight <= Limits::Small));
 		const AxisAlignedBox3 obox = obj->GetBox();
 
@@ -1131,8 +1268,4 @@
 		const float sum = noValidSplit ? 1e25f : objectsLeft * al + objectsRight * ar;
 #endif
-		/*cout << "pos=" << (*cit).mPos << "\t q=(" << objectsLeft << "," << objectsRight <<")\t r=(" 
-			 << lbox.SurfaceArea() << "," << rbox.SurfaceArea() << ")" << endl;
-		cout << "minborder: " << minBorder << " maxborder: " << maxBorder << endl;
-	    cout << "cost= " << sum << endl;*/
 	
 		if (sum < minSum) 
@@ -1183,5 +1316,5 @@
 	PrepareLocalSubdivisionCandidates(tData, axis);
 
-	const float totalRenderCost = EvalAbsCost(tData.mNode->mObjects);
+	const float totalRenderCost = (float)tData.mNode->mObjects.size();
 	float objectsLeft = 0, objectsRight = totalRenderCost;
   
@@ -1242,8 +1375,6 @@
 		Intersectable *obj = (*cit).mObject;
 
-		const float renderCost = ViewCellsManager::EvalRenderCost(obj);
-		
-		objectsLeft += renderCost;
-		objectsRight -= renderCost;
+		objectsLeft ++;;
+		objectsRight --;
 
 		const AxisAlignedBox3 obox = obj->GetBox();
@@ -1270,11 +1401,6 @@
 	
 		const bool noValidSplit = ((objectsLeft <= Limits::Small) || (objectsRight <= Limits::Small));
-		const float sum =  noValidSplit ? 1e25 : objectsLeft * al + objectsRight * ar;
+		const float sum =  noValidSplit ? 1e25f : objectsLeft * al + objectsRight * ar;
       
-		/*cout << "pos=" << (*cit).mPos << "\t q=(" << objectsLeft << "," << objectsRight <<")\t r=(" 
-			 << lbox.SurfaceArea() << "," << rbox.SurfaceArea() << ")" << endl;
-		cout << "minborder: " << minBorder << " maxborder: " << maxBorder << endl;
-	    cout << "cost= " << sum << endl;*/
-	
 		if (sum < minSum) 
 		{	
@@ -1367,5 +1493,5 @@
 	//-- left and right and evaluate the cost funcion
 
-	// prepare the heuristics by setting mailboxes and counters
+	// prepare the heuristics, set mailboxes and counters
 	const float totalVol = PrepareHeuristics(tData, axis);
 	
@@ -1374,5 +1500,5 @@
 	float volRight = totalVol;
 	
-	const float nTotalObjects = EvalAbsCost(tData.mNode->mObjects);
+	const float nTotalObjects = (float)tData.mNode->mObjects.size();
 	float nObjectsLeft = 0;
 	float nObjectsRight = nTotalObjects;
@@ -1419,33 +1545,14 @@
 		EvalHeuristicsContribution(object, volLeft, volRight);
 
-#if USE_BETTER_RENDERCOST_EST
-
-		const float rc = ViewCellsManager::EvalRenderCost(object);
-		
-		nObjectsLeft += rc;
-		nObjectsRight -= rc;
-	
-#else
 		++ nObjectsLeft;
 		-- nObjectsRight;
-#endif
 	
 		// split is only valid if #objects on left and right is not zero
 		const bool noValidSplit = (nObjectsRight <= Limits::Small);
 
-#if BOUND_RENDERCOST
-
-		const float rcLeft = max(nObjectsLeft, MIN_RENDERCOST);
-		const float rcRight = max(nObjectsRight, MIN_RENDERCOST);
-		
-		// the heuristics
-	    const float sum = noValidSplit ? 
-			1e25f : volLeft * (float)rcLeft + volRight * (float)rcRight;
-#else
-	
 		// the heuristics
 	    const float sum = noValidSplit ? 
 			1e25f : volLeft * (float)nObjectsLeft + volRight * (float)nObjectsRight;
-#endif
+
 		
 #ifdef GTP_DEBUG
@@ -1829,5 +1936,4 @@
 #endif
 		}
-
 	}
 
@@ -1887,5 +1993,5 @@
 	const float viewSpaceArea = mViewCellsManager->GetViewSpaceBox().SurfaceArea();
 
-	return EvalAbsCost(leaf->mObjects) * area / viewSpaceArea;
+	return (float)leaf->mObjects.size() * area / viewSpaceArea;
 }
 
@@ -1896,5 +2002,5 @@
 	//-- render cost heuristics
 
-	const float objRenderCost = EvalAbsCost(objects);
+	const float objRenderCost = (float)objects.size();
 
 	const float viewSpaceVol = mViewCellsManager->GetViewSpaceBox().GetVolume();
@@ -2923,79 +3029,4 @@
 
 
-BvhNode *BvHierarchy::SubdivideAndCopy(SplitQueue &tQueue, 
-									   SubdivisionCandidate *splitCandidate)
-{
-	BvhSubdivisionCandidate *sc = 
-		static_cast<BvhSubdivisionCandidate *>(splitCandidate);
-	BvhTraversalData &tData = sc->mParentData;
-
-	BvhNode *currentNode = tData.mNode;
-	BvhNode *oldNode = (BvhNode *)splitCandidate->mEvaluationHack;
-
-	if (!oldNode->IsLeaf())
-	{	
-		//////////////
-		//-- continue subdivision
-
-		BvhTraversalData tFrontData;
-		BvhTraversalData tBackData;
-			
-		BvhInterior *oldInterior = static_cast<BvhInterior *>(oldNode);
-		
-		sc->mFrontObjects.clear();
-		sc->mBackObjects.clear();
-
-		oldInterior->GetFront()->CollectObjects(sc->mFrontObjects);
-		oldInterior->GetBack()->CollectObjects(sc->mBackObjects);
-		
-		// evaluate the changes in render cost and pvs entries
-		EvalSubdivisionCandidate(*sc, false, true);
-
-		// create new interior node and two leaf node
-		currentNode = SubdivideNode(*sc, tFrontData, tBackData);
-	
-		//oldNode->mRenderCostDecr += sc->GetRenderCostDecrease();
-		//oldNode->mPvsEntriesIncr += sc->GetPvsEntriesIncr();
-		
-		//oldNode->mRenderCostDecr = sc->GetRenderCostDecrease();
-		//oldNode->mPvsEntriesIncr = sc->GetPvsEntriesIncr();
-		
-		///////////////////////////
-		//-- push the new split candidates on the queue
-		
-		BvhSubdivisionCandidate *frontCandidate = new BvhSubdivisionCandidate(tFrontData);
-		BvhSubdivisionCandidate *backCandidate = new BvhSubdivisionCandidate(tBackData);
-
-		frontCandidate->SetPriority((float)-oldInterior->GetFront()->GetTimeStamp());
-		backCandidate->SetPriority((float)-oldInterior->GetBack()->GetTimeStamp());
-
-		frontCandidate->mEvaluationHack = oldInterior->GetFront();
-		backCandidate->mEvaluationHack = oldInterior->GetBack();
-
-		// cross reference
-		tFrontData.mNode->SetSubdivisionCandidate(frontCandidate); 
-		tBackData.mNode->SetSubdivisionCandidate(backCandidate);
-
-		//cout << "f: " << frontCandidate->GetPriority() << " b: " << backCandidate->GetPriority() << endl;
-		tQueue.Push(frontCandidate);
-		tQueue.Push(backCandidate);
-	}
-
-	/////////////////////////////////
-	//-- node is a leaf => terminate traversal
-
-	if (currentNode->IsLeaf())
-	{
-		// this leaf is no candidate for splitting anymore
-		// => detach subdivision candidate
-		tData.mNode->SetSubdivisionCandidate(NULL); 
-		// detach node so we don't delete it with the traversal data
-		tData.mNode = NULL;
-	}
-	
-	return currentNode;
-}
-
-
 void BvHierarchy::CollectObjects(const AxisAlignedBox3 &box,
 								 ObjectContainer &objects)
@@ -3171,13 +3202,13 @@
 
 // HACK
-float BvHierarchy::GetRenderCostIncrementially(BvhNode *node) const
-{
-	if (node->mRenderCost < 0) // render cost must be evaluated ...
-	{
+float BvHierarchy::GetTriangleSizeIncrementially(BvhNode *node) const
+{
+	if (node->mRenderCost < 0)
+	{
+		//cout <<"p";
 		if (node->IsLeaf())
 		{
 			BvhLeaf *leaf = static_cast<BvhLeaf *>(node);
-			node->mRenderCost = EvalAbsCost(leaf->mObjects);		
-			//if (leaf->mObjects.size() < 100) cout <<"p";
+			node->mRenderCost = (float)leaf->mObjects.size();
 		}
 		else
@@ -3185,6 +3216,6 @@
 			BvhInterior *interior = static_cast<BvhInterior *>(node);
 		
-			node->mRenderCost = GetRenderCostIncrementially(interior->GetFront()) + 
-								GetRenderCostIncrementially(interior->GetBack());
+			node->mRenderCost = GetTriangleSizeIncrementially(interior->GetFront()) + 
+								GetTriangleSizeIncrementially(interior->GetBack());
 		}
 	}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 2280)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 2332)
@@ -166,4 +166,7 @@
 	Environment::GetSingleton()->GetStringValue("ViewCells.samplingType", buf);
 
+	Environment::GetSingleton()->GetFloatValue("ViewCells.triangleWeight", mTriangleWeight);
+	Environment::GetSingleton()->GetFloatValue("ViewCells.objectWeight", mObjectWeight);
+
 	// mix of sampling strategies
 	if (1)
@@ -306,4 +309,7 @@
 	Debug << "export pvs for view cells: " << mExportPvs << endl;
 	Debug << "use kd pvs " << mUseKdPvs << endl;
+
+	Debug << "triangle weight: " << mTriangleWeight << endl;
+	Debug << "object weight: " << mObjectWeight << endl;
 
 	Debug << endl;
@@ -1702,22 +1708,8 @@
 
 
-float ViewCellsManager::EvalRenderCost(Intersectable *obj) //const
-{
-	switch (sRenderCostEvaluationType)
-	{
-	case PER_OBJECT:
-		return 1.0f;
-	
-	case PER_TRIANGLE:
-		{
-			return (float)obj->NumberOfFaces();
-		}
-	default:
-		cout << "default" << endl;
-		return 1.0f;
-	}
-
-	// should not come here
-	return 0.0f;
+
+float ViewCellsManager::ComputeRenderCost(const int tri, const int obj) //const
+{
+	return max((float)tri * mTriangleWeight, (float)obj * mObjectWeight);
 }
 
@@ -2095,4 +2087,5 @@
 			sum += ComputeSampleContribution(*(*it), addContributions, storeViewCells, useHitObjects);
 		}
+
 	}
 
@@ -2792,8 +2785,8 @@
 
 	++ mSamplesStat.mRays;
-	
+
 	if (!ray.mTerminationObject)
-	  return 0.0f;
-	
+		return 0.0f;
+
 	static Ray hray;
 	hray.Init(ray);
@@ -2801,19 +2794,20 @@
 	float tmin = 0, tmax = 1.0;
 
-	if (!GetViewSpaceBox().GetRaySegment(hray, tmin, tmax) || (tmin > tmax)) {
-	  // cerr<<"ray outside view space box\n";
-	  return 0;
+	if (!GetViewSpaceBox().GetRaySegment(hray, tmin, tmax) || (tmin > tmax)) 
+	{
+		// cerr<<"ray outside view space box\n";
+		return 0;
 	}
 
 	Vector3 origin = hray.Extrap(tmin);
 	Vector3 termination = hray.Extrap(tmax);
-	
+
 	ViewCell::NewMail();
-	
+
 	viewCellCastTimer.Entry();
 
 	static ViewCellContainer viewCells;
 	static VssRay *lastVssRay = NULL;
-	
+
 	// check if last ray was not same ray with reverse direction
 	if (1) 
@@ -2824,11 +2818,11 @@
 	{
 		viewCells.clear();
-		
+
 		// traverse the view space subdivision
 		CastLineSegment(origin, termination, viewCells);
 
-        lastVssRay = &ray;
-	}
-	
+		lastVssRay = &ray;
+	}
+
 	viewCellCastTimer.Exit();
 
@@ -2837,24 +2831,24 @@
 	if (storeViewCells)
 	{	
-	  // cerr << "Store viewcells should not be used in the test!" << endl;
-	  // copy viewcells memory efficiently
+		// cerr << "Store viewcells should not be used in the test!" << endl;
+		// copy viewcells memory efficiently
 #if VSS_STORE_VIEWCELLS
-	  ray.mViewCells.reserve(viewCells.size());
-	  ray.mViewCells = viewCells;
+		ray.mViewCells.reserve(viewCells.size());
+		ray.mViewCells = viewCells;
 #else
-	  cerr << "Vss store viewcells not supported." << endl;
-	  exit(1);
+		cerr << "Vss store viewcells not supported." << endl;
+		exit(1);
 #endif
 	}
-	
+
 	Intersectable *terminationObj;
-	
+
 	objTimer.Entry();
 
 	// obtain pvs entry (can be different from hit object)
 	terminationObj = ray.mTerminationObject;
-	
+
 	objTimer.Exit();
-	
+
 	pvsTimer.Entry();
 
@@ -2864,5 +2858,5 @@
 	{
 		ComputeViewCellContribution(*it, 
-									ray, 
+			                        ray, 
 									terminationObj, 
 									ray.mTermination, 
@@ -2875,18 +2869,18 @@
 	if (ray.mPvsContribution)
 		++ mSamplesStat.mContributingRays;
-	
+
 #if AVG_RAY_CONTRIBUTIONS
 	ray.mRelativePvsContribution /= (float)viewCells.size();
 #endif
-  
+
 #if USE_RAY_LENGTH_AS_CONTRIBUTION
 	float c = 0.0f;
 	if (terminationObj) 
-	  c = ray.Length();
+		c = ray.Length();
 	ray.mRelativePvsContribution = ray.mPvsContribution = c;
 	return c;
 #else
 	return ABS_CONTRIBUTION_WEIGHT*ray.mPvsContribution +
-	  (1.0f - ABS_CONTRIBUTION_WEIGHT)*ray.mRelativePvsContribution;
+		(1.0f - ABS_CONTRIBUTION_WEIGHT)*ray.mRelativePvsContribution;
 #endif
 }
@@ -6898,5 +6892,5 @@
 
 			ofstream ofstr(filename.c_str());
-			mHierarchyManager->EvaluateSubdivision2(ofstr, splitsStepSize, false, useHisto, histoMem, pass);
+			mHierarchyManager->EvaluateSubdivision(ofstr, splitsStepSize, false, useHisto, histoMem, pass);
 
 			timeDiff = TimeDiff(startTime, GetTime());
@@ -7000,3 +6994,66 @@
 
 
-}
+#if TEST_PACKETS
+#ifdef USE_SSE
+
+float ViewCellsManager::ComputeSampleContributions(const VssRayContainer &rays,
+												   const bool addContributions,
+												   const bool storeViewCells,
+												   const bool useHitObjects)
+{
+	float sum = 0.0f;
+
+	VssRayContainer::const_iterator it, it_end = rays.end();
+
+	VssRayContainer tmpRays;	
+	RayPacket packet;
+
+	for (it = rays.begin(); it != it_end; ++ it) 
+	{
+		if (!ViewCellsConstructed()) 
+		{
+			// view cells not yet constructed
+			// just take the lenghts of the rays as contributions
+			if ((*it)->mTerminationObject)
+			{
+				sum += (*it)->Length();
+			}
+		} 
+		else 
+		{
+			sum += ComputeSampleContribution(*(*it), addContributions, storeViewCells, useHitObjects);
+
+			tmpRays.push_back(new VssRay(*it));
+			
+			if (tmpRays.size() == 4)
+			{
+				RayPacket packet(tmpRays);
+
+				mHierarchyManager->CastLineSegment(packet);
+
+				for (int i = 0; i < 4; ++ i)
+				{
+					ComputeSampleContribution(tmpRays[i], addContributions, true, useHitObjects);
+				}
+
+				// compare results
+				//////////
+
+				CLEAR_CONTAINER(tmpRays);
+			}
+		}
+	}
+
+	cout << "view cell cast time: " << viewCellCastTimer.TotalTime() << " s" << endl;
+	Debug << "view cell cast time: " << viewCellCastTimer.TotalTime() << " s" << endl;
+
+	cout << "pvs time: " << pvsTimer.TotalTime() << " s" << endl;
+	Debug << "pvs time: " << pvsTimer.TotalTime() << " s" << endl;
+	
+	return sum;
+}
+
+#endif
+#endif
+
+}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 2227)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 2332)
@@ -824,5 +824,5 @@
 
 		obj->Mail();
-		renderCost += mViewCellsManager->EvalRenderCost(obj);
+		renderCost ++;
 	}
 
@@ -836,5 +836,5 @@
 		if (!obj->Mailed())
 		{
-			renderCost += ViewCellsManager::EvalRenderCost(obj);
+			renderCost ++;
 		}
 	}
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.h
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.h	(revision 2255)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/BvHierarchy.h	(revision 2332)
@@ -52,5 +52,5 @@
 	int Nodes() const {return nodes;}
 	int Interior() const { return nodes / 2; }
-	int Leaves() const { return (nodes / 2) + 1; }
+	int Leaves() const { return nodes / 2 + 1; }
 	
 	double AvgDepth() const 
@@ -668,16 +668,9 @@
 	void StoreSampledObjects(ObjectContainer &sampledObjects, const ObjectContainer &objects);
 
-	///////////////////////////
-	// hacks in order to provide interleaved heurisitcs
-
-	BvhNode *SubdivideAndCopy(SplitQueue &tQueue, SubdivisionCandidate *splitCandidate);
-
 	/////////////////////////////////
 
-	static inline float EvalAbsCost(const ObjectContainer &objects);
-
 	void CollectObjects(const AxisAlignedBox3 &box, ObjectContainer &objects);
 
-	float GetRenderCostIncrementially(BvhNode *node) const;
+	float GetTriangleSizeIncrementially(BvhNode *node) const;
 
 	void Compress();
@@ -995,4 +988,7 @@
 	*/
 	void SetUniqueNodeIds();
+
+	void UpdateViewCells(const BvhSubdivisionCandidate &sc);
+
 
 protected:
@@ -1101,44 +1097,6 @@
 
 
-float BvHierarchy::EvalAbsCost(const ObjectContainer &objects)
-{
-	float result;
-
-#if USE_BETTER_RENDERCOST_EST
-	
-	const float switchcost = 1.0f;
-
-	float o = 0;
-
-	ObjectContainer::const_iterator oit, oit_end = objects.end();
-
-	for (oit = objects.begin(); oit != oit_end; ++ oit)
-	{
-		o += ViewCellsManager::GetRendercost(*oit);
-	}
-
-	float n = (float)objects.size() * switchcost;
-	
-#else
-	
-	result = (float)objects.size();
+
+}
 
 #endif
-
-#if BOUND_RENDERCOST
-	
-	if (result > MIN_RENDERCOST)
-		return result;
-	else
-	{
-		//std::cout << "b";
-		return MIN_RENDERCOST;
-	}
-#endif
-
-	return result;
-}
-
-}
-
-#endif
Index: /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.cpp
===================================================================
--- /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.cpp	(revision 2176)
+++ /GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.cpp	(revision 2332)
@@ -15,4 +15,8 @@
 // $$JB HACK
 #define KD_PVS_AREA (1e-5f)
+
+#define TYPE_INTERIOR -2
+#define TYPE_LEAF -3
+
 
 namespace GtpVisibilityPreprocessor {
@@ -1098,46 +1102,4 @@
 }
 
-int
-KdTree::CollectLeafPvs()
-{
-
-	// matt: no more kd pvs
-    int totalPvsSize = 0;
-	/*
-  stack<KdNode *> nodeStack;
-  
-  nodeStack.push(mRoot);
-  
-  while (!nodeStack.empty()) {
-    KdNode *node = nodeStack.top();
-    nodeStack.pop();
-    if (node->IsLeaf()) {
-      KdLeaf *leaf = (KdLeaf *)node;
-      for (int j=0; j < leaf->mObjects.size(); j++) {
-	Intersectable *object = leaf->mObjects[j];
-	if (!object->Mailed()) {
-	  object->Mail();
-	  // add this node to pvs of all nodes it can see
-	  KdPvsMap::iterator ni = object->mKdPvs.mEntries.begin();
-	  for (; ni != object->mKdPvs.mEntries.end(); ni++) {
-	    KdNode *node = (*ni).first;
-	    // $$ JB TEMPORARY solution -> should add object PVS or explictly computed
-	    // kd tree PVS
-		float contribution;
-		if (leaf->mKdPvs.AddSample(node, 1.0f, contribution))
-	      totalPvsSize++;
-	  }
-	}
-      }
-    } else {
-      KdInterior *interior = (KdInterior *)node;
-      nodeStack.push(interior->mFront);
-      nodeStack.push(interior->mBack);
-    }
-  }
-*/
-  return totalPvsSize;
-}
-
 
 KdNode *
@@ -1223,8 +1185,4 @@
 
 
-#define TYPE_INTERIOR -2
-#define TYPE_LEAF -3
-
-
 void KdTree::ExportBinLeaf(OUT_STREAM &stream, KdLeaf *leaf)
 {
@@ -1319,5 +1277,5 @@
 	OUT_STREAM stream(filename.c_str(), OUT_BIN_MODE);
 	
-	//if (!stream.is_open()) return false;
+	if (!stream.is_open()) return false;
 
 	// export binary version of mesh
@@ -1400,8 +1358,7 @@
 	DEL_PTR(mRoot);
   
-	KdNode *node = LoadNextNode(stream, NULL, objects);
-	mRoot = node;
-
-	tStack.push(TraversalData(node, mBox, 0));
+	mRoot = LoadNextNode(stream, NULL, objects);
+
+	tStack.push(TraversalData(mRoot, mBox, 0));
 	mStat.Reset();
 	mStat.nodes = 1;
